<template>
	<div>
		<button ref="backToTop" class="button--back-to-top"
				:class="{'button--back-to-top--hidden' : !backToTopIsVisible}"
				@click="scrollToTop"
		>
			<span class="back-to-top-bg"></span>
		</button>
	</div>
</template>

<script>
export default {
	name: "ButtonBackToTop",
	props: {
		backToTopIsVisible: Boolean
	},
	methods: {
		scrollToTop() {
			window.scroll(0, 0);
		},

		followMouse(offsetX, offsetY) {
			// Supposedly the most reliable method to check for touch input (pointer: coarse = pointing device with limited accuracy)
			if (!window.matchMedia("(pointer: coarse)").matches) {
					this.$refs.backToTop.style.bottom = "unset";
					this.$refs.backToTop.style.top = (offsetY - (this.$refs.backToTop.clientHeight / 2)) + "px";
				// enlarge button when near it
				if (offsetX > (window.innerWidth - (this.$refs.backToTop.clientWidth * 2.5))) {
					this.$refs.backToTop.classList.add("button--back-to-top--zoomed");
				} else {
					this.$refs.backToTop.classList.remove("button--back-to-top--zoomed");
				}
			}
		}
	},

	mounted() {
		window.addEventListener("mousemove", (e) => this.followMouse(e.clientX, e.clientY));
	},

	destroyed() {
		window.removeEventListener("mousemove", (e) => this.followMouse(e.clientX, e.clientY));
	}
}
</script>

<style scoped>

</style>